--- a/libtomcrypt/makefile_include.mk
+++ b/libtomcrypt/makefile_include.mk
@@ -75,6 +75,13 @@ endif
 
 LTC_CFLAGS += -Wno-type-limits
 
+ifdef OPENWRT_BUILD
+  ifeq (-Os,$(filter -Os,$(CFLAGS)))
+    LTC_CFLAGS += -DLTC_SMALL_CODE
+  endif
+else
+  ### ! OPENWRT_BUILD
+
 ifdef LTC_DEBUG
 $(info Debug build)
 # compile for DEBUGGING (required for ccmalloc checking!!!)
@@ -102,6 +109,9 @@ endif
 endif # COMPILE_SMALL
 endif # COMPILE_DEBUG
 
+  ### ! OPENWRT_BUILD
+endif
+
 
 ifneq ($(findstring clang,$(CC)),)
 LTC_CFLAGS += -Wno-typedef-redefinition -Wno-tautological-compare -Wno-builtin-requires-header -Wno-missing-field-initializers
--- a/libtommath/makefile_include.mk
+++ b/libtommath/makefile_include.mk
@@ -37,6 +37,9 @@ CFLAGS += -Wsystem-headers -Wdeclaration
 CFLAGS += -Wstrict-prototypes -Wpointer-arith
 endif
 
+ifndef OPENWRT_BUILD
+  ### ! OPENWRT_BUILD
+
 ifdef COMPILE_DEBUG
 #debug
 CFLAGS += -g3
@@ -58,6 +61,9 @@ endif
 endif # COMPILE_SIZE
 endif # COMPILE_DEBUG
 
+  ### ! OPENWRT_BUILD
+endif
+
 ifneq ($(findstring clang,$(CC)),)
 CFLAGS += -Wno-typedef-redefinition -Wno-tautological-compare -Wno-builtin-requires-header
 endif
